/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;

/**
 * ファイル管理
 * @author tondol
 */
public class FileManager {
    static ArrayList<FileItem> items = null;
    
    public FileManager() {
        items = new ArrayList<FileItem>();
    }
    
    /**
     * アイテムを追加
     */
    private void addItem(FileItem item) throws IOException {
        items.add(item);
        MainApp.client.addItem(item);
    }
    
    /**
     * アイテムを削除
     */
    private void delItem(FileItem item) throws IOException {
        items.remove(item);
        MainApp.client.delItem(item);
    }
    
    /**
     * ハッシュからファイルを取得
     */
    public FileItem getItem(String digest) {
        FileItem ret = null;
        for (int i=0;i<items.size();i++){
            if (digest.equals(items.get(i).hash)) {
                ret = items.get(i);
            }
        }
        return ret;
    }
    
    /**
     * アイテムをクリア
     */
    public void clearItems() throws IOException {
        while (!items.isEmpty()) {
            delItem(items.get(0));
        }
    }
    
    /**
     * 公開アイテムを更新
     */
    public void updateItems() throws IOException {
        File array[] = new File(MainApp.option.upDir).listFiles();
        ArrayList<FileItem> recent = new ArrayList<FileItem>(array.length);
        // リスト生成
        for(int i=0;i<array.length;i++){
            if (!array[i].isFile()) continue;
            recent.add(new FileItem(array[i]));
        }
        // 現在のリストを複製
        ArrayList<FileItem> backup = new ArrayList<FileItem>(items.size());
        for(int i=0;i<items.size();i++){
            backup.add(items.get(i));
        }
        // 新規取得分を追加
        for(int i=0;i<recent.size();i++){
            if (backup.contains(recent.get(i))) continue;
            addItem(recent.get(i));
        }
        // 新規消去分を削除
        for(int i=0;i<backup.size();i++){
            if (recent.contains(backup.get(i))) continue;
            delItem(backup.get(i));
        }
    }
    
    /**
     * リモートのアイテムを検索
     */
    public void searchRemote(String word) throws IOException {
        // 検索要求を送信
        MainApp.client.sendMessage("LS " + word);
        // ファイル数を取得
        String msg = MainApp.client.recvMessage();
        int size = Integer.parseInt(msg);
        ArrayList<FileItem> output = new ArrayList<FileItem>(size);
        // 各ファイル情報を取得
        for(int i=0;i<size;i++){
            String str = MainApp.client.recvMessage();
            output.add(new FileItem(str));
        }
        // 表に反映する
        MainApp.window.modelSearch.setItems(output);
    }
}
