/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.IOException;
import java.net.Socket;
import java.io.*;

/**
 * ファイル受信タスク
 * @author hosaka
 */
public class TaskDownload extends TaskAbstract implements Runnable {
    private Socket         socket = null;
    private BufferedReader reader = null;
    private PrintWriter    writer = null;
    private Thread         thread = null;
    private FileItem       item   = null;
    private long           loaded = 0;
    private BufferedInputStream isstream = null;
    private FileOutputStream    ofstream = null;
    
    public TaskDownload(FileItem item) throws IOException {
        socket = new Socket(item.host, item.port);
        // 文字コードの自動認識
        reader = new BufferedReader(new InputStreamReader(
                socket.getInputStream(), "JISAUTODETECT"));
        writer = new PrintWriter(socket.getOutputStream());
        // ファイル情報を送信
        this.item = item;
        MainApp.window.modelTasks.addItem(this);
        writer.println(item.hash);
        writer.flush();
        // 処理を開始
        thread = new Thread(this);
        thread.start();
    }
    
    public void run() {
        try {
            recv();
        } catch(Exception e) {
            ;
        } finally {
            try {
                close();
            } catch(Exception e) {
                ;
            }
        }
    }
    
    private int readFully(byte[] buf) throws IOException {
        int offset = 0;
        int remain = buf.length;
        while (remain > 0) {
            long tmp = isstream.read(buf, offset, remain);
            if (tmp < 0) break;
            remain -= tmp;
            offset += tmp;
        }
        return offset;
    }
    
    private void recv() throws IOException {
        // ランダムアクセス用に開く
        File outFile = new File(MainApp.option.downDir + item.name);
        isstream  = new BufferedInputStream(socket.getInputStream());
        ofstream  = new FileOutputStream(outFile, true);
        byte[] buf = new byte[128*1024];
        // シーク位置を決定
        loaded = outFile.length();
        writer.println(loaded);
        writer.flush();
        // ダウンロード
        try {
            while (item.size - loaded > 0) {
                int tmp = readFully(buf);
                if (tmp == 0) break;
                ofstream.write(buf, 0, (int)tmp);
                loaded += tmp;
                MainApp.window.modelTasks.updateItem(this);
            }
        } finally {
            isstream.close();
            ofstream.close();
        }
    }
    
    @Override public void close() throws IOException {
        if (writer != null) writer.close();
        if (socket != null) socket.close();
        MainApp.window.modelTasks.deleteItem(this);
    }

    @Override public String getName() {
        return item.name;
    }

    @Override public String getType() {
        return "受信タスク";
    }

    @Override public String getStatus() {
        int per = (int)((double) loaded / item.size * 100.0);
        return per + "% - " + loaded + "/" + item.size;
    }
}
