/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.util.ArrayList;
import javax.swing.table.AbstractTableModel;

/**
 * タスクをJTableに表示するためのモデル
 * @author tondol
 */
public class TaskTableModel extends AbstractTableModel {
    ArrayList<TaskAbstract> items = new ArrayList<TaskAbstract>();
    
    public TaskAbstract getItem(int index) {
        return items.get(index);
    }
    
    public void addItem(TaskAbstract task) {
        items.add(task);
        int index = items.indexOf(task);
        fireTableRowsInserted(index, index);
    }
    
    public void deleteItem(TaskAbstract task) {
        int index = items.indexOf(task);
        items.remove(task);
        fireTableRowsDeleted(index, index);
    }
    
    public void updateItem(TaskAbstract task) {
        int index = items.indexOf(task);
        fireTableRowsUpdated(index, index);
    }
    
    public int getRowCount() {
        return items.size();
    }

    public int getColumnCount() {
        return 3;
    }

    @Override public String getColumnName(int column) {
        String values[] = { "ファイル名", "種類", "状態" };
        return values[column];
    }

    public Object getValueAt(int rowIndex, int columnIndex) {
        switch (columnIndex) {
            case 0: return items.get(rowIndex).getName();
            case 1: return items.get(rowIndex).getType();
            case 2: return items.get(rowIndex).getStatus();
            default: return null;
        }
    }
}
