/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package p4uclient;

import java.io.*;
import java.net.Socket;

/**
 * ファイル送信タスク
 * @author hosaka
 */
public class TaskUpload extends TaskAbstract implements Runnable {
    private Socket         socket = null;
    private BufferedReader reader = null;
    private PrintWriter    writer = null;
    private Thread         thread = null;
    private FileItem       item   = null;
    private long           loaded = 0;
    private RandomAccessFile     ifstream = null;
    private BufferedOutputStream osstream = null;
    
    public TaskUpload(Socket socket) throws IOException {
        this.socket = socket;
        // 文字コードの自動認識
        reader = new BufferedReader(new InputStreamReader(
                socket.getInputStream(), "JISAUTODETECT"));
        writer = new PrintWriter(socket.getOutputStream());
        // ファイル情報を取得
        String digest = reader.readLine();
        item = MainApp.files.getItem(digest);
        MainApp.window.modelTasks.addItem(this);
        // 処理を開始
        thread = new Thread(this);
        thread.start();
    }
    
    public void run() {
        try {
            send();
        } catch(IOException e) {
            ;
        } finally {
            try {
                close();
            } catch(Exception e) {
                ;
            }
        }
    }
    
    private int readFully(byte[] buf) throws IOException {
        int offset = 0;
        int remain = buf.length;
        while (remain > 0) {
            long tmp = ifstream.read(buf, offset, remain);
            if (tmp < 0) break;
            remain -= tmp;
            offset += tmp;
        }
        return offset;
    }
    
    private void send() throws IOException {
        // ランダムアクセス用に開く
        ifstream  = new RandomAccessFile(MainApp.option.upDir + item.name, "r");
        osstream  = new BufferedOutputStream(socket.getOutputStream());
        byte[] buf = new byte[128*1024];
        // シーク位置を決定
        loaded = Long.parseLong(reader.readLine());
        ifstream.seek(loaded);
        // アップロード
        try {
            while (item.size - loaded > 0) {
                int tmp = readFully(buf);
                if (tmp == 0) break;
                osstream.write(buf, 0, tmp);
                loaded += tmp;
                MainApp.window.modelTasks.updateItem(this);
            }
        } finally {
            ifstream.close();
            osstream.close();
        }
    }
    
    @Override public void close() throws IOException {
        if (writer != null) writer.close();
        if (socket != null) socket.close();
        MainApp.window.modelTasks.deleteItem(this);
    }

    @Override public String getName() {
        return item.name;
    }

    @Override public String getType() {
        return "送信タスク";
    }

    @Override public String getStatus() {
        int per = (int)((double) loaded / item.size * 100.0);
        return per + "% - " + loaded + "/" + item.size;
    }
}
